/*******************************************************************************
*  skVC0706.h - VC0706-chipp֐Cuwb_t@C                      *
*               (Digital Video Processor VC0706)                               *
*                                                                              *
* ============================================================================ *
*  VERSION DATE        BY                    CHANGE/COMMENT                    *
* ---------------------------------------------------------------------------- *
*  1.01    2017-03-20  ޒH[(ނ)  Create                            *
* ============================================================================ *
*  Arduino IDE 1.8.1 (Ardino Duemilanove 328/UNO)                              *
*******************************************************************************/
#ifndef _SKVC0706_H_
#define _SKVC0706_H_

#include "arduino.h"
#include <SoftwareSerial.h>


// WX^̒萔`
#define VC070X_READDATA_BUFFSZ         64    // 摜f[^Mobt@TCY
#define VC070X_READDATA_DELAY          10    // 摜f[^MInterval timew(x0.01mSP)

#define VC070X_MOTION_DETECT_ON         1    // ̃j^[OJn
#define VC070X_MOTION_DETECT_OFF        0    // ̃j^[O~
#define VC070X_COMM_MOTION_DETECTED  0x39    // oɑMR}h
#define VC070X_COLOR_AUTO            0x00    // J[[h͎
#define VC070X_COLOR_COLOR           0x01    // J[[hCOLOR
#define VC070X_COLOR_MONO            0x02    // J[[h͔
#define VC070X_640X480               0x00    // 摜̃TCY640x480̑傫
#define VC070X_320X240               0x11    // 摜̃TCY320x240̑傫
#define VC070X_160X120               0x22    // 摜̃TCY160x120̑傫


// G[Ԃꂽ̏\
union VC070X_ERROR_t {
     struct {
          uint8_t cmd_no ;
          uint8_t err_no ;
     } ;
     uint16_t info ;
} ;

/*******************************************************************************
*	NX̒`                                                              *
*******************************************************************************/
class skVC070x
{
  public:
         skVC070x(SoftwareSerial *ss_p) ;
     void begin(uint32_t baud) ;
     void skVC070x::flush() ;
     uint16_t GetError() ;
     char *GetVersion() ;
     int Reset() ;
     int PowerCtl(int info,uint16_t time) ;
     int MotionCtlEnable() ;
     int MotionDetect() ;
     int SetMotionCtl(int val) ;
     int GetImageSize() ;
     int SetImageSize(int sz) ;
     int GetColorSts() ;
     int SetColorCtl(int val) ;
     int GetCompression() ;
     int SetCompression(int val) ;
     int ResumeVideo() ;
     uint32_t TakePicture() ;
     char *ReadPicture(uint16_t adrs,int len) ;

  private:
     SoftwareSerial *swSerial ;
     char ReadReturnBuff[VC070X_READDATA_BUFFSZ+12] ;// R}hMobt@
     union VC070X_ERROR_t Erro ;                     // ŌɃG[Ԃꂽ̃G[

     int read(char *buff,int len) ;
     int sendread(char *cmd,int snd_su,int rcv_su) ;

};

#endif
